<template>
  <div>
    <a-form>
      <a-tabs v-model="tabName" type="card">
        <a-tab-pane
            :tab="$t('functional-analysis.add-modal.dfmea-feature-add')"
            key="addFunction">
          <HotTable
              ref="addFunction"
              key="addFunction"
              v-if="tabName === 'addFunction'"
              :formData="functionData"
              :headers="headers"
              :columns="columns"
              :focusCol="focusCol"
              @formDataChange="functionDataChange"
          />
          <!-- <a-checkbox v-model="checked">{{ $t('functional-analysis.add-modal.Whether-to-synchronize-to-the-knowledge-base') }}</a-checkbox> -->
        </a-tab-pane>
        <!-- 知识库-产品功能库添加-->
        <a-tab-pane
            :tab="$t('functional-analysis.add-modal.library-add')"
            key="addProductFunctionLibrary">
          <AddProductFunctionFromLibrary
              ref="addProductFunctionLibrary"
              v-if="tabName === 'addProductFunctionLibrary'"
              :struTypeCode="struTypeCode"
              :struId="checkedNode.id"
              :selectType.sync="selectType"
              @dataChange="productFunctionLibraryDataChange"
          />
        </a-tab-pane>
      </a-tabs>
    </a-form>
    <div slot="footer" class="mt10 text-right">
      <a-button @click="closeModal">
        {{ $t('global-btn.cancel') }}
      </a-button>
      <a-button
          type="primary"
          class="ml10"
          @click="save()"
          :loading="saveLoading"
          v-preventReClick>
        {{ $t('global-btn.confirm') }}
      </a-button>
    </div>
  </div>
</template>
<script>

import HotTable from "@/components/HotTable";
import AddDFMEALibrary from "./components/AddDFMEALibrary";
import {checkHotTableLength} from "@/utils/validate";
import AddProductFunctionFromLibrary from "./components/AddProductFunctionFromLibrary";

export default {
  name: "AddFunction",
  components: {
    HotTable,
    AddDFMEALibrary,
    AddProductFunctionFromLibrary
  },
  props: {
    struTypeCode: {
      default: '',
      type: String
    },
    checkedNode: {
      type: Object
    }
  },
  data() {
    return {
      functionData: [], // 添加功能
      DFMEALibraryData: [], // 添加DFMEA库
      tabName: "addFunction",
      columns: [
        {data: "name", type: "text"},
      ],
      headers: [this.$t('functional-analysis.add-modal.function')],
      focusCol: 0,
      saveLoading: false,
      selectType: 1,
      checked: true, //是否同步到知识库
      productFunctionLibraryData: []
    };
  },
  methods: {
    /**
     * 接受子组件知识库的数据
     */
    productFunctionLibraryDataChange(val) {
      this.productFunctionLibraryData = val;
    },
    /**
     * 接受子组件handsontable数据
     */
    functionDataChange(val) {
      this.functionData = val;
    },
    /**
     * 接受子组件DFMEA库数据
     */
    DFMEALibraryDataChange(val) {
      this.DFMEALibraryData = val;
    },
    /**
     * 关闭模态框
     */
    closeModal() {
      this.$emit("closeModal");
    },
    /**
     * 刷新结构树
     */
    initTree() {
      this.$emit("initTree");
    },
    /**
     * 保存
     */
    save() {
      let _that = this;
      if (_that.tabName === 'addFunction') { // 功能添加：保存
        _that.saveFunction();
      } else if (_that.tabName === 'addDFMEALibrary') { // DFMEA库选择：保存
        _that.saveMFMEALibrary();
      } else if (_that.tabName === 'addProductFunctionLibrary') { // 知识库添加：保存
        _that.saveProductFunctionLibraryToDfmea();
      }
    },
    /**
     * 构建：功能数据
     */
    buildFunctionData() {
      return this.functionData.map((item) => {
        return {name: item.name, code: item.code}
      }).filter((item) => {
        return item.name;
      });
    },
    /**
     * 校验：功能数据
     */
    validateFunctionData(functionData) {
      if (functionData && functionData.length > 0) {
        let flag = true;
        functionData.some((item, idx) => {
          if (checkHotTableLength(item.name, 1000)) {
            this.$message.warning(this.$t('global-message.warn.function-name-length', [idx + 1]));
            flag = false
            return true;
          }
        });
        return flag;
      } else {
        this.$message.warning(this.$t('global-message.warn.please-enter-not-name-line'))
        return false;
      }
    },
    /**
     * 保存：功能
     */
    saveFunction() {
      let _that = this;
      // 构建数据
      let functionData = _that.buildFunctionData();
      // 校验
      if (!_that.validateFunctionData(functionData)) return;
      _that.saveLoading = true; // 开启：加载中...
      _that.$api.saveFunction({
        fmeaId: _that.$store.getters.rfmeaId,
        struId: _that.checkedNode.id,
        struTypeCode: _that.struTypeCode,
        mfmeaStruInputModels: functionData,
        // libraryPushFlag: _that.checked
        libraryPushFlag: false,
        libraryStruNo: getLibraryNo('Fn')
      }).then((res) => {
        if (res.flag) {
          // 添加成功，关闭弹窗，刷新右侧树
          _that.$message.success(res.message, 1);
          _that.closeModal();
          _that.initTree();
        } else {
          _that.$message.error(res.message, 1);
        }
      }).catch((error) => {
        _that.$message.error(error.response.data.message,1);
      }).finally(() => {
        _that.saveLoading = false; // 关闭：加载中...
      })
    },
    /**
     * 校验：DFAME库选择
     */
    validateDFMEALibraryData() {
      let _that = this;
      if (_that.DFMEALibraryData.length === 0) {
        _that.$message.warning(this.$t('global-message.warn.please-select-node'));
        return false;
      }
      return true;
    },
    /**
     * 保存：DFAME库选择
     */
    saveMFMEALibrary() {
      let _that = this;
      // 校验
      if (!_that.validateDFMEALibraryData()) return;
      // 构建数据
      let ids = _that.DFMEALibraryData.map((item) => {
        return item.id;
      });
      _that.saveLoading = true; // 开启：加载中...
      _that.$api.saveMFMEALibrarySelect({
        fmeaId: _that.$store.getters.rfmeaId,
        struId: _that.checkedNode.id,
        selectType: _that.selectType,
        struIds: ids.toString(),
      }).then((res) => {
        if (res.flag) {
          // 添加成功，关闭弹窗，刷新右侧树
          _that.$message.success(res.message, 1);
          _that.closeModal();
          _that.initTree();
        } else {
          _that.$message.error(res.message, 1);
        }
      }).catch((error) => {
        _that.$message.error(error.response.data.message,1);
      }).finally(() => {
        _that.saveLoading = false; // 关闭：加载中...
      })
    },
    /**
     * 校验：知识库-产品功能库选择
     */
    validateProductFunctionLibraryData() {
      let _that = this;
      if (_that.productFunctionLibraryData.length === 0) {
        _that.$message.warning(this.$t('global-message.warn.please-select-node'));
        return false;
      }
      return true;
    },
    /**
     * 保存：知识库添加
     */
    saveProductFunctionLibraryToDfmea() {
      let _that = this;
      // 校验
      if (!_that.validateProductFunctionLibraryData()) return;
      _that.saveLoading = true; // 开启：加载中...
      _that.$api.saveNodeFromLibrarySelect({
        fmeaId: _that.$store.getters.rfmeaId,
        parentStruId: _that.checkedNode.id,
        selectType: _that.selectType,
        libraryTypeCode: _that.struTypeCode, // 功能
        libraryIds: _that.productFunctionLibraryData
      }).then((res) => {
        if (res.flag) {
          // 添加成功，关闭弹窗，刷新右侧树
          _that.$message.success(res.message, 1);
          _that.closeModal();
          _that.initTree();
        } else {
          _that.$message.error(res.message, 1);
        }
      }).catch((error) => {
        _that.$message.error(error.response.data.message, 1);
      }).finally(() => {
        _that.saveLoading = false; // 关闭：加载中...
      })
    },
  }
};
</script>
<style lang="less">

</style>
